#include <iostream>
#include <string>
#define MAXN 10005

using namespace std;

struct pacijent
{
	string krvna_grupa;
	int potrebna_kolicina;
	int grupa_O=0;
	int grupa_A=0;
	int grupa_B=0;
	int grupa_AB=0;
};

pacijent niz[MAXN];

int main()
{
	int n;
	cin>>n;
	int o,a,b,ab;
	cin>>o>>a>>b>>ab;
	for(int i=0;i<n;i++) 
	{
		cin>>niz[i].krvna_grupa>>niz[i].potrebna_kolicina;
		
		if(niz[i].krvna_grupa=="O")
		{
			niz[i].grupa_O+=niz[i].potrebna_kolicina;
			o-=niz[i].potrebna_kolicina;
		}
		else if(niz[i].krvna_grupa=="A")
		{
			if(a<niz[i].potrebna_kolicina)
			{
				niz[i].grupa_A=a;
				a=0;
				o-=niz[i].potrebna_kolicina;
				niz[i].grupa_O+=niz[i].potrebna_kolicina;
			}
			else
			{
				a-=niz[i].potrebna_kolicina;
				niz[i].grupa_A+=niz[i].potrebna_kolicina;
			}
		}
		else if(niz[i].krvna_grupa=="B")
		{
			if(b<niz[i].potrebna_kolicina)
			{
				niz[i].grupa_B=b;
				b=0;
				o-=niz[i].potrebna_kolicina;
				niz[i].grupa_O+=niz[i].potrebna_kolicina;
			}
			else
			{
				b-=niz[i].potrebna_kolicina;
				niz[i].grupa_B+=niz[i].potrebna_kolicina;
			}
		}
	}
/*	for(int i=0;i<n;i++)
	{
		if(niz[i].krvna_grupa=="AB")
		{
			if(ab<niz[i].potrebna_kolicina)
			{
				niz[i].grupa_AB=ab;
				niz[i].potrebna_kolicina-=ab;
				ab=0;
				if(b<niz[i].potrebna_kolicina)
				{
					niz[i].grupa_B=b;
					niz[i].potrebna_kolicina-=b;
					b=0;
					if(a<niz[i].potrebna_kolicina)
					{
						niz[i].grupa_A=a;
						niz[i].potrebna_kolicina-=a;
						a=0;
						o-=niz[i].potrebna_kolicina;
						niz[i].grupa_O+=niz[i].potrebna_kolicina;
					}
					else
					{
						a-=niz[i].potrebna_kolicina;
						niz[i].grupa_A+=niz[i].potrebna_kolicina;
					}		
				}
				else
				{
					b-=niz[i].potrebna_kolicina;
					niz[i].grupa_B+=niz[i].potrebna_kolicina;
				}
			}
			else
			{
				ab-=niz[i].potrebna_kolicina;
				niz[i].grupa_AB+=niz[i].potrebna_kolicina;
			}
		}
	}*/
	if(o>=0)
	{
		cout<<"moguce"<<endl;
		for(int i=0;i<n;i++) cout<<niz[i].grupa_O<<" "<<niz[i].grupa_A<<" "<<niz[i].grupa_B<<" "<<niz[i].grupa_AB<<endl;
	}
	else
	{
		cout<<"nemoguce";
	}
	return 0;
}